#include "pest.h"
#include "time.h"
#include "serial.h"
#include "log.h"
#include "def.h"
#include "util.h"
#include "string.h"
#include "config.h"
#include "state.h"

#define TEXT_STAMP_BUF      256

extern pestev_f     pest_func;

void console_send(peer_t         *chan,
                  char const     *speaker,
                  uint8_t const  *m,
                  bool            stampold){

  char      text[TEXT_STAMP_BUF+TEXT_BUF];
  char     *text_end  = text+sizeof(text);
  char     *t         = text;
  uint64_t  stamp;
  uint64_t *con;
  unsigned  e = chan ? PEST_DIRECT : PEST_BROADCAST;

  con = chan ? &chan->con_stamp : &con_stamp;
  read_u64(m+TIMESTAMP_OFF,&stamp);

  if(stampold && stamp < *con){
    char const *fmt = *con-stamp < SEC_DAY ?
                      GETDATA_STAMP_FMT     " " :
                      GETDATA_OLDSTAMP_FMT  " ";
    t += time_str(t,text_end-t,fmt,stamp);
  }

  cpy_text(t,text_end-t,m);
  if(pest_func){
    pest_func(e,speaker,text);
  }

  if(!stampold){
    *con = stamp;
  }
}

void console_stamp(peer_t *p,uint64_t stamp){
  uint64_t *con;

  con   = p ? &p->con_stamp : &con_stamp;
  *con  = stamp;
}

