#include "pest.h"
#include "packet.h"
#include "crypto.h"
#include "time.h"
#include "config.h"
#include "state.h"
#include <assert.h>

bool ignore_send(peer_t *chan,pkey_t *pk){
  uint8_t   r[RED_SIZE];
  uint8_t  *m = r+MESSAGE_OFF;
  hash_t    hash;

  if(!rng_read(m,MESSAGE_SIZE)) return 0;
  hash_data(hash,m,MESSAGE_SIZE);
  return send_message(CMD_IGNORE,r,hash,chan,pk);
}

void ignore_broadcast(uint64_t ntime){
  uint64_t next;

  if(ntime < ignore_next) return;
  if(ignore_next > 0){
    ignore_send(0,0);
  }
  if(!rng_read(&next,sizeof(next))) return;
  next         %= igint*NSEC_MSEC*2;
  ignore_next   = ntime+next;
}

